#include "img_test.h"
//#include "PCCsocket.h"

gchar *file = "into";	
static GdkPixmap *pixmap = NULL;

float accel_v = 0.0;
float rang = 0.0;

int main(int argc, char* argv[]){

	gtk_init(&argc, &argv);
	
	sockThread();

	initWidget();
	btnDestroy();
	drawLine();


	setLayout();
	showDialog();

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	이벤트 처리 관련 함수
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
static gboolean configure_event( GtkWidget *widget, GdkEventConfigure *event ){
  if (pixmap)
    g_object_unref (pixmap);

  pixmap = gdk_pixmap_new (widget->window, widget->allocation.width, widget->allocation.height, -1);
  gdk_draw_rectangle (pixmap, widget->style->white_gc, TRUE, 0, 0, widget->allocation.width, widget->allocation.height);

  return TRUE;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	repaint를 요구할 경우
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
static gboolean expose_event( GtkWidget *widget, GdkEventExpose *event ){
  gdk_draw_drawable (widget->window,
		     widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		     pixmap,
		     event->area.x, event->area.y,
		     event->area.x, event->area.y,
		     event->area.width, event->area.height);

  return FALSE;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	실제로 픽셀을 그려주는 부분
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
static void draw_brush( GtkWidget *widget, gdouble x, gdouble y){
  GdkRectangle update_rect;

  update_rect.x = x - 5;
  update_rect.y = y - 5;
  update_rect.width = 10;
  update_rect.height = 10;
  gdk_draw_rectangle (pixmap, widget->style->black_gc, TRUE,update_rect.x, update_rect.y, update_rect.width, update_rect.height);
  gtk_widget_queue_draw_area (widget, update_rect.x, update_rect.y, update_rect.width, update_rect.height);
}

static gboolean button_press_event( GtkWidget *widget, GdkEventButton *event ){
  if (event->button == 1 && pixmap != NULL)
    draw_brush (widget, event->x, event->y);

  return TRUE;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	마우스 관련 이벤트 처리 
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
static gboolean motion_notify_event( GtkWidget *widget, GdkEventMotion *event ){
	int x, y;
	GdkModifierType state;

	if (event->is_hint)
		gdk_window_get_pointer (event->window, &x, &y, &state);
	else{
		x = event->x;
		y = event->y;
		state = event->state;
	}

	if (state & GDK_BUTTON1_MASK && pixmap != NULL){
		draw_brush (widget, x, y);
		SendMSG(150);
	}
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	라인을 그려주는 함수 부분
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void drawLine(){
	drawing_area = gtk_drawing_area_new ();
//	pan = gtk_drawing_area_new ();
	gtk_widget_set_size_request (GTK_WIDGET(drawing_area), 240, 320);
	gtk_widget_set_size_request (GTK_WIDGET(pan), 240, 320);
	gtk_widget_show (drawing_area);

	g_signal_connect (G_OBJECT (drawing_area), "expose_event", G_CALLBACK (expose_event), NULL);
	g_signal_connect (G_OBJECT (drawing_area),"configure_event", G_CALLBACK (configure_event), NULL);

	/* Event signals */

	g_signal_connect (G_OBJECT (drawing_area), "motion_notify_event", G_CALLBACK (motion_notify_event), NULL);
	g_signal_connect (G_OBJECT (drawing_area), "button_press_event", G_CALLBACK (button_press_event), NULL);

////////////////////////////////////////////////////////////////
/*
	g_signal_connect (G_OBJECT (pan), "expose_event", G_CALLBACK (expose_event), NULL);
	g_signal_connect (G_OBJECT (pan),"configure_event", G_CALLBACK (configure_event), NULL);



	g_signal_connect (G_OBJECT (pan), "motion_notify_event", G_CALLBACK (motion_notify_event), NULL);
	g_signal_connect (G_OBJECT (pan), "button_press_event", G_CALLBACK (button_press_event), NULL);

	gtk_widget_set_events (pan, GDK_EXPOSURE_MASK | GDK_LEAVE_NOTIFY_MASK 
				| GDK_BUTTON_PRESS_MASK | GDK_POINTER_MOTION_MASK  | GDK_POINTER_MOTION_HINT_MASK);
*/
////////////////////////////////////////////////////////////////

	gtk_widget_set_events (drawing_area, GDK_EXPOSURE_MASK | GDK_LEAVE_NOTIFY_MASK 
				| GDK_BUTTON_PRESS_MASK | GDK_POINTER_MOTION_MASK  | GDK_POINTER_MOTION_HINT_MASK);

}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	가속도 값을 이용한 거리 추출 부분
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void calSpeed(float v0, float a, float t1, float t0, float s0){
	accel_v = v0 + (a * t1);
	rang = s0 + (v0 * (t1 - t0)) + (0.5 * ( a * pow(t1,2) ));
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	컴포넌트 초기화 및 생성
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int initWidget(){
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_default_size(GTK_WINDOW(window), 200, 200);
	gtk_widget_set_size_request (GTK_WIDGET(pan), 240, 320);
	//gtk_window_set_resize(GTK_WIDGET(window), 200, 200);

	visualBox = gtk_vbox_new(FALSE, FALSE);
	gtk_container_add(GTK_CONTAINER(window), visualBox);

	pan = gtk_image_new_from_file(file);
	g_signal_connect (G_OBJECT (drawing_area), "expose_event", G_CALLBACK (expose_event), NULL);
	
	gtk_signal_connect(GTK_OBJECT(window), "destroy", GTK_SIGNAL_FUNC(gtk_main_quit), NULL);

	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	소켓 통신을 위한 스레드 생성 부분
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int sockThread(){
	pthread_create(&sock_thread, NULL, socketready, (void*)window);
	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	UI의 레이아웃을 정하는 부분
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void setLayout(){
//	gtk_box_pack_start_defaults(GTK_BOX(visualBox), drawing_area);
	gtk_box_pack_start_defaults(GTK_BOX(visualBox), pan);
//	gtk_box_pack_start (GTK_BOX (visualBox), drawing_area, TRUE, TRUE, 0);
//	gtk_box_pack_start_defaults(GTK_BOX(visualBox), gtk_image_new_from_file(file));
//	gtk_box_pack_start_defaults(GTK_BOX(visualBox), button);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	종료 버튼 (현재 보이지 않음)
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void btnDestroy(){
	button = gtk_button_new_with_mnemonic("_Exit");
	gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	화면에 UI를 호출 하는 함수
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void showDialog(){
	gtk_widget_show_all(window);
	gtk_main();
}
